'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _babelTypes = require('babel-types');

var t = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ImportRegistry = function () {
  function ImportRegistry(packageName, moduleNames) {
    _classCallCheck(this, ImportRegistry);

    this.packageName = packageName;
    this.moduleNames = moduleNames;
    this.directModuleNames = moduleNames.map(function (moduleName) {
      return packageName + '/' + moduleName;
    });
    this.identifiers = [];
  }

  _createClass(ImportRegistry, [{
    key: 'clear',
    value: function clear() {
      this.identifiers = [];
    }
  }, {
    key: 'scan',
    value: function scan(path) {
      var _this = this;

      var source = path.node.source.value;
      if (source === this.packageName) {
        return void path.node.specifiers.forEach(function (spec) {
          return _this.scanNormalImport(spec);
        });
      }
      if (this.directModuleNames.includes(source)) {
        return void path.node.specifiers.forEach(function (spec) {
          return _this.scanDirectImport(spec);
        });
      }
    }
  }, {
    key: 'scanNormalImport',
    value: function scanNormalImport(spec) {
      var _this2 = this;

      var pushAllModuleNames = function pushAllModuleNames() {
        return _this2.moduleNames.forEach(function (moduleName) {
          _this2.identifiers.push(spec.local.name + '.' + moduleName);
        });
      };

      if (t.isImportDefaultSpecifier(spec)) {
        pushAllModuleNames();
      } else if (t.isImportSpecifier(spec)) {
        if (this.moduleNames.includes(spec.imported.name)) {
          this.identifiers.push(spec.local.name);
        } else if (spec.imported.name === 'default') {
          pushAllModuleNames();
        }
      }
    }
  }, {
    key: 'scanDirectImport',
    value: function scanDirectImport(spec) {
      if (t.isImportDefaultSpecifier(spec)) {
        this.identifiers.push(spec.local.name);
      } else if (t.isImportSpecifier(spec)) {
        this.identifiers.push(spec.local.name);
      }
    }
  }, {
    key: 'match',
    value: function match(node) {
      if (t.isIdentifier(node)) {
        return this.identifiers.includes(node.name);
      }

      if (!t.isMemberExpression(node) || node.computed) {
        return false;
      }

      var object = node.object,
          property = node.property;

      if (!t.isIdentifier(object) || !t.isIdentifier(property)) {
        return false;
      }

      var memberExp = object.name + '.' + property.name;
      return this.identifiers.includes(memberExp);
    }
  }]);

  return ImportRegistry;
}();

exports.default = ImportRegistry;